
// c++ -O2 -I. -I/opt/local/include re2test.cpp -L/opt/local/lib -lre2

#include "re2/re2.h"
#include <re2/stringpiece.h>
#include <iostream>
#include <fstream>
#include <cassert>
#include "reflex/timer.h"

#define RUNS 1000

using namespace re2;

int main()
{
  RE2 tokens("(?m)(((?:\\s+))|((?:(?:\\Q//\\E)(?:[^\\x0a]|\\\\\\n)*\\n))|((?:(?:\\Q/*\\E)(?:[^\\x2a]|\\*+[^/])*(?:\\Q*/\\E)))|((?:^[\\x09\\x20]*#(?:.|\\\\\\r?\\n)+))|((?:[A-Z_a-z][0-9A-Z_a-z]*))|((?:[\\x2b\\x2d]\\d*(?:\\d|\\.\\d|\\d\\.)\\d*(?:[Ee][\\x2b\\x2d]?\\d+)?[FLfl]?))|((?:[\\x2b\\x2d]?(?:(?:0[0-7]+)|(?:0[Xx][0-9A-Fa-f]+)|(?:0|[1-9]\\d*))(?:[Ll]{0,2}[Uu]?|[Uu][Ll]{0,2})))|((?:L?'(?:\\\\.|[^\\x0a'\\x5c])*'))|((?:L?\"(?:\\\\.|\\\\\\r?\\n|[^\\x0a\"\\x5c])*\"))|((?:\\Q+=\\E))|((?:\\Q++\\E))|((?:\\Q+\\E))|((?:\\Q-=\\E))|((?:\\Q--\\E))|((?:\\Q->\\E))|((?:\\Q-\\E))|((?:\\Q==\\E))|((?:\\Q=\\E))|((?:\\Q<=\\E))|((?:\\Q<<=\\E))|((?:\\Q<<\\E))|((?:\\Q<\\E))|((?:\\Q>=\\E))|((?:\\Q>>=\\E))|((?:\\Q>>\\E))|((?:\\Q>\\E))|((?:\\Q!=\\E))|((?:\\Q!\\E))|((?:\\Q,\\E))|((?:\\Q;\\E))|((?:\\Q...\\E))|((?:\\Q.\\E))|((?:\\Q^=\\E))|((?:\\Q^\\E))|((?:\\Q~\\E))|((?:\\Q*=\\E))|((?:\\Q*\\E))|((?:\\Q/=\\E))|((?:\\Q/\\E))|((?:\\Q%=\\E))|((?:\\Q%\\E))|((?:\\Q&=\\E))|((?:\\Q&&\\E))|((?:\\Q&\\E))|((?:\\Q|=\\E))|((?:\\Q||\\E))|((?:\\Q|\\E))|((?:\\Q(\\E))|((?:\\Q)\\E))|((?:\\Q[\\E))|((?:\\Q]\\E))|((?:\\Q{\\E))|((?:\\Q}\\E))|((?:\\Q::\\E))|((?:\\Q:\\E))|((?:\\Q?\\E)))");

  assert(tokens.ok());

  std::ifstream file("re2test.cpp");
  std::string str((std::istreambuf_iterator<char>(file)), std::istreambuf_iterator<char>());
  file.close();

  size_t n = 0;
  reflex::timer_type t;
  reflex::timer_start(t);
  for (int run = 0; run < RUNS; ++run)
  {
    StringPiece sp(str);
    StringPiece m;
    n = 0;
    while (RE2::Consume(&sp, tokens, &m))
    {
      ++n;
      // std::cout << m << std::endl;
    }
  }
  float dt = reflex::timer_elapsed(t);
  std::cout << n << " matches, elapsed " << 1000*dt/RUNS << " micro seconds" << std::endl;

}
